Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 2613)
@@ -6,5 +6,4 @@
 # if defined key_dimgout
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers 
    USE dom_oce         ! ocean space and time domain
@@ -15,17 +14,15 @@
    PRIVATE
 
-   !! * Accessibility
    PUBLIC dia_wri_dimg            ! called by trd_mld (eg)
    PUBLIC dia_wri_dimg_alloc      ! called by nemo_alloc in nemogcm.F90
 
+
+   !! These workspace arrays are inside the module so that we can make them
+   !! allocatable in a clean way. Not done in wrk_nemo because these are of KIND(sp).
+   REAL(sp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: z42d    ! 2d temporary workspace (sp)
+   REAL(sp), ALLOCATABLE, SAVE, DIMENSION(:)   :: z4dep   ! vertical level (sp)
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
-
-   !! These workspace arrays are inside the module so that we can make them
-   !! allocatable in a clean way. Not done in wrk_nemo because these are
-   !! of KIND(sp).
-   REAL(sp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: z42d  ! 2d temporary workspace (sp)
-   REAL(sp), ALLOCATABLE, SAVE,   DIMENSION(:) :: z4dep ! vertical level (sp)
-
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -33,41 +30,36 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
-  FUNCTION dia_wri_dimg_alloc()
-     !!---------------------------------------------------------------------
-     !!        *** ROUTINE dia_wri_dimg_alloc ***
-     !!
-     !!---------------------------------------------------------------------
-     INTEGER :: dia_wri_dimg_alloc
-     !!---------------------------------------------------------------------
-
-     ALLOCATE(z42d(jpi,jpj), z4dep(jpk), Stat=dia_wri_dimg_alloc)
-
-     IF(dia_wri_dimg_alloc /= 0)THEN
-        CALL ctl_warn('dia_wri_dimg_alloc: allocation of array failed.')
-     END IF
-
+   FUNCTION dia_wri_dimg_alloc()
+      !!---------------------------------------------------------------------
+      !!        *** ROUTINE dia_wri_dimg_alloc ***
+      !!
+      !!---------------------------------------------------------------------
+      INTEGER :: dia_wri_dimg_alloc   ! return value
+      !!---------------------------------------------------------------------
+      !
+      ALLOCATE( z42d(jpi,jpj), z4dep(jpk), STAT=dia_wri_dimg_alloc )
+      !
+      IF( lk_mpp                  )   CALL mpp_sum ( dia_wri_dimg_alloc )
+      IF( dia_wri_dimg_alloc /= 0 )   CALL ctl_warn('dia_wri_dimg_alloc: allocation of array failed.')
+      !
   END FUNCTION dia_wri_dimg_alloc
 
 
-  SUBROUTINE dia_wri_dimg(cd_name, cd_text, ptab, klev, cd_type , ksubi )
+  SUBROUTINE dia_wri_dimg( cd_name, cd_text, ptab, klev, cd_type , ksubi )
     !!-------------------------------------------------------------------------
     !!        *** ROUTINE dia_wri_dimg ***
     !!
-    !! ** Purpose : write ptab in the dimg file cd_name, with comment cd_text.
-    !!       ptab has klev x 2D fields
+    !! ** Purpose :   write ptab in the dimg file cd_name, with comment cd_text.
+    !!              ptab has klev x 2D fields
     !!
-    !! ** Action :
-    !!       Define header variables from the config parameters
-    !!       Open the dimg file on unit inum = 14 ( IEEE I4R4 file )
-    !!       Write header on record 1
-    !!       Write ptab on the following klev records
+    !! ** Action :   Define header variables from the config parameters
+    !!               Open the dimg file on unit inum = 14 ( IEEE I4R4 file )
+    !!               Write header on record 1
+    !!               Write ptab on the following klev records
     !!
-    !! History :
-    !!   03-12 (J.M. Molines ) : Original. Replace ctl_opn, writn2d
+    !! History :  2003-12 (J.M. Molines ) : Original. Replace ctl_opn, writn2d
     !!---------------------------------------------------------------------------
-    !! * Arguments
     CHARACTER(len=*),INTENT(in) ::   &
          &                            cd_name,  &  ! dimg file name
@@ -91,4 +83,7 @@
     CHARACTER(LEN=4) :: clver='@!01'           ! dimg string identifier
     !!---------------------------------------------------------------------------
+
+    !                                      ! allocate dia_wri_dimg array
+    IF( dia_wri_dimg_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'dia_wri_dimg : unable to allocate arrays' )
 
     !! * Initialisations
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diahth.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diahth.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diahth.F90	(revision 2613)
@@ -21,4 +21,5 @@
    USE phycst          ! physical constants
    USE in_out_manager  ! I/O manager
+   USE lib_mpp         ! MPP library
    USE iom             ! I/O library
 
@@ -29,15 +30,15 @@
    PUBLIC   dia_hth_alloc ! routine called by nemogcm.F90
 
-   LOGICAL , PUBLIC, PARAMETER          ::   lk_diahth = .TRUE.   !: thermocline-20d depths flag
+   LOGICAL , PUBLIC, PARAMETER          ::   lk_diahth = .TRUE.    !: thermocline-20d depths flag
    ! note: following variables should move to local variables once iom_put is always used 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hth                  !: depth of the max vertical temperature gradient [m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hd20                 !: depth of 20 C isotherm                         [m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hd28                 !: depth of 28 C isotherm                         [m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   htc3                 !: heat content of first 300 m                    [W]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hth    !: depth of the max vertical temperature gradient [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hd20   !: depth of 20 C isotherm                         [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hd28   !: depth of 28 C isotherm                         [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   htc3   !: heat content of first 300 m                    [W]
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -46,14 +47,13 @@
 
    FUNCTION dia_hth_alloc()
-     !!---------------------------------------------------------------------
-      IMPLICIT none
+      !!---------------------------------------------------------------------
       INTEGER :: dia_hth_alloc
-
-      ALLOCATE(hth(jpi,jpj), hd20(jpi,jpj), hd28(jpi,jpj), htc3(jpi,jpj), &
-               Stat=dia_hth_alloc)
-
-      IF(dia_hth_alloc /= 0)THEN
-         CALL ctl_warn('dia_hth_alloc: failed to allocate arrays.')
-      END IF
+      !!---------------------------------------------------------------------
+      !
+      ALLOCATE(hth(jpi,jpj), hd20(jpi,jpj), hd28(jpi,jpj), htc3(jpi,jpj), STAT=dia_hth_alloc)
+      !
+      IF( lk_mpp           )   CALL mpp_sum ( dia_hth_alloc )
+      IF(dia_hth_alloc /= 0)   CALL ctl_warn('dia_hth_alloc: failed to allocate arrays.')
+      !
    END FUNCTION dia_hth_alloc
 
@@ -117,9 +117,7 @@
                      zmaxdzT(jpi,jpj), &
                      zthick(jpi,jpj),  &
-                     zdelr(jpi,jpj), Stat=ji)
-            IF(ji /= 0)THEN
-               WRITE(*,*) 'ERROR: allocation of arrays failed in dia_hth'
-               CALL mppabort()
-            END IF
+                     zdelr(jpi,jpj), STAT=ji)
+            IF( lk_mpp  )   CALL mpp_sum(ji)
+            IF( ji /= 0 )   CALL ctl_stop( 'STOP', 'dia_hth : unable to allocate standard ocean arrays' )
          END IF
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 2613)
@@ -75,19 +75,20 @@
 CONTAINS
 
-  FUNCTION dia_wri_alloc()
-    !!----------------------------------------------------------------------
-    IMPLICIT none
-    INTEGER :: dia_wri_alloc
-    INTEGER, DIMENSION(2) :: ierr
-    !!----------------------------------------------------------------------
-    
-    ierr = 0
-
-    ALLOCATE(ndex_hT(jpi*jpj), ndex_hU(jpi*jpj), ndex_hV(jpi*jpj), &
-             ndex_T(jpi*jpj*jpk), ndex_U(jpi*jpj*jpk), ndex_V(jpi*jpj*jpk), &
-             Stat=ierr(1))
-
-    dia_wri_alloc = MAXVAL(ierr)
-
+   FUNCTION dia_wri_alloc()
+      !!----------------------------------------------------------------------
+      IMPLICIT none
+      INTEGER :: dia_wri_alloc
+      INTEGER, DIMENSION(2) :: ierr
+      !!----------------------------------------------------------------------
+      !
+      ierr = 0
+      !
+      ALLOCATE( ndex_hT(jpi*jpj) , ndex_T(jpi*jpj*jpk) ,     &
+         &      ndex_hU(jpi*jpj) , ndex_U(jpi*jpj*jpk) ,     &
+         &      ndex_hV(jpi*jpj) , ndex_V(jpi*jpj*jpk) , STAT=ierr(1) )
+         !
+      dia_wri_alloc = MAXVAL(ierr)
+      IF( lk_mpp )   CALL mpp_sum( ierr )
+      !
   END FUNCTION dia_wri_alloc
 
@@ -106,4 +107,5 @@
    !!   'key_iomput'                                        use IOM library
    !!----------------------------------------------------------------------
+
    SUBROUTINE dia_wri( kt )
       !!---------------------------------------------------------------------
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diawri_dimg.h90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diawri_dimg.h90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DIA/diawri_dimg.h90	(revision 2613)
@@ -69,8 +69,4 @@
     INTEGER ,INTENT(in) :: kt
     !!
-    INTEGER :: inbsel, jk
-    INTEGER :: iyear,imon,iday
-    INTEGER, SAVE :: nmoyct 
-
 #if defined key_diainstant
     LOGICAL, PARAMETER :: ll_dia_inst=.TRUE.  !: for instantaneous output
@@ -78,12 +74,13 @@
     LOGICAL, PARAMETER :: ll_dia_inst=.FALSE. !: for average output
 #endif
-
-    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  um , vm   ! used to compute mean u, v fields
-    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  wm        ! used to compute mean w fields
-    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  avtm      ! used to compute mean kz fields
-    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  tm , sm   ! used to compute mean t, s fields
-    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  fsel      ! used to compute mean 2d fields
+    INTEGER              , SAVE                    ::  nmoyct 
+    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  um , vm, wm   ! mean u, v, w fields
+    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  avtm          ! mean kz fields
+    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  tm , sm       ! mean t, s fields
+    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::  fsel          ! mean 2d fields
+    
+    INTEGER :: inbsel, jk
+    INTEGER :: iyear,imon,iday
     REAL(wp) :: zdtj
-    !
     CHARACTER(LEN=80) :: clname
     CHARACTER(LEN=80) :: cltext
@@ -260,9 +257,6 @@
        cltext=TRIM(cexper)//' U(m/s) '//TRIM(clmode)
        !
-       IF( ll_dia_inst) THEN 
-          CALL dia_wri_dimg(clname, cltext, un, jpk, 'T')
-
-       ELSE 
-          CALL dia_wri_dimg(clname, cltext, um, jpk, 'T')
+       IF( ll_dia_inst) THEN   ;   CALL dia_wri_dimg(clname, cltext, un, jpk, 'T')
+       ELSE                    ;   CALL dia_wri_dimg(clname, cltext, um, jpk, 'T')
        ENDIF
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2613)
@@ -72,13 +72,12 @@
       !!                  ***  routine dyn_spg_ts_alloc  ***
       !!----------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: dyn_spg_ts_malloc
+      INTEGER ::   dyn_spg_ts_alloc   ! return value
       !!----------------------------------------------------------------------
-
+      !
       ALLOCATE(ftnw(jpi,jpj), ftne(jpi,jpj), ftsw(jpi,jpj), ftse(jpi,jpj), &
-               un_b(jpi,jpj), vn_b(jpi,jpj), ub_b(jpi,jpj), vb_b(jpi,jpj), &
-               Stat=dyn_spg_ts_malloc)
-
-   END FUNCTION dyn_spg_ts_malloc
+         &      un_b(jpi,jpj), vn_b(jpi,jpj), ub_b(jpi,jpj), vb_b(jpi,jpj), &
+         &      STAT=dyn_spg_ts_alloc)
+         !
+   END FUNCTION dyn_spg_ts_alloc
 
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 2613)
@@ -16,5 +16,5 @@
    PUBLIC
 
-   PUBLIC flo_oce_alloc ! Routine called in nemogcm.F90
+   PUBLIC   flo_oce_alloc   ! Routine called in nemogcm.F90
 
    LOGICAL, PUBLIC, PARAMETER ::   lk_floats = .TRUE.    !: float flag
@@ -34,5 +34,5 @@
    REAL(wp), PUBLIC, DIMENSION(jpnfl) ::   tpifl, tpjfl, tpkfl   !: (i,j,k) indices of float position
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wb              !: vertical velocity at previous time step (m s-1).
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wb   !: vertical velocity at previous time step (m s-1).
    
    !                                            !!! * namelist namflo : langrangian floats *
@@ -43,12 +43,14 @@
    INTEGER, PUBLIC  ::   nn_stockfl = 450        !: frequency of float restart file
 
+   !!----------------------------------------------------------------------
 CONTAINS
 
    FUNCTION flo_oce_alloc()
-     IMPLICIT none
-     INTEGER :: flo_oce_alloc
-
-     ALLOCATE(wb(jpi,jpj,jpk), Stat=flo_oce_alloc)
-
+      !!----------------------------------------------------------------------
+      INTEGER :: flo_oce_alloc
+      !!----------------------------------------------------------------------
+      !
+      ALLOCATE(wb(jpi,jpj,jpk), Stat=flo_oce_alloc)
+      !
    END FUNCTION flo_oce_alloc
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90	(revision 2613)
@@ -24,5 +24,5 @@
 
    PUBLIC   flo_wri          ! routine called by floats.F90
-   PUBLIC   flow_wri_alloc   ! routine called by nemogcm.F90
+   PUBLIC   flo_wri_alloc   ! routine called by nemogcm.F90
 
    INTEGER ::   jfl      ! number of floats
@@ -37,5 +37,5 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -43,17 +43,17 @@
 CONTAINS
 
-   FUNCTION flow_wri_alloc
+   FUNCTION flo_wri_alloc
       !!-------------------------------------------------------------------
       !!                ***  ROUTINE flo_wri_alloc  ***
       !!-------------------------------------------------------------------
-      INTEGER :: flow_wri_alloc
-
-      ALLOCATE(ztemp(jpk,jpnfl), zsal(jpk,jpnfl), Stat=flow_wri_alloc)
-
-      IF(flow_wri_alloc /= 0)THEN
-         CALL ctl_warn('flow_wri_alloc: failed to allocate arrays.')
-      END IF
-
-   END FUNCTION flow_wri_alloc
+      INTEGER :: flo_wri_alloc
+      !!-------------------------------------------------------------------
+      !
+      ALLOCATE(ztemp(jpk,jpnfl), zsal(jpk,jpnfl), Stat=flo_wri_alloc)
+      !
+      IF( lk_mpp             )   CALL mpp_sum ( flo_wri_alloc )
+      IF( flo_wri_alloc /= 0 )   CALL ctl_warn('flo_wri_alloc: failed to allocate arrays.')
+      !
+   END FUNCTION flo_wri_alloc
 
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 2613)
@@ -20,4 +20,5 @@
    USE lib_print     ! formated print library
    USE nc4interface  ! NetCDF4 interface
+   USE lib_mpp, ONLY :   lk_mpp
 
    IMPLICIT NONE
@@ -137,6 +138,6 @@
 CONTAINS
 
-   SUBROUTINE ctl_stop( cd1, cd2, cd3, cd4, cd5,   &
-      &                 cd6, cd7, cd8, cd9, cd10 )
+   SUBROUTINE ctl_stop( cd_stop, cd1, cd2, cd3, cd4, cd5 ,   &
+      &                          cd6, cd7, cd8, cd9, cd10 )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE  stop_opa  ***
@@ -145,6 +146,6 @@
       !!                increment the error number (nstop) by one.
       !!----------------------------------------------------------------------
-      CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd1, cd2, cd3, cd4, cd5
-      CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd6, cd7, cd8, cd9, cd10
+      CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd_stop, cd1, cd2, cd3, cd4, cd5
+      CHARACTER(len=*), INTENT(in), OPTIONAL ::           cd6, cd7, cd8, cd9, cd10
       !!----------------------------------------------------------------------
       !
@@ -167,4 +168,13 @@
       IF( numsol     /= -1 )   CALL FLUSH(numsol    )
       IF( numevo_ice /= -1 )   CALL FLUSH(numevo_ice)
+      !
+      IF( PRESENT(cd_stop) ) THEN
+         IF( cd_stop == 'STOP' ) THEN
+            WRITE(numout,*) 
+            WRITE(numout,*) 'huge E-R-R-O-R : immediate stop'
+            IF(lk_mpp)   CALL mppstop()
+            STOP
+         ENDIF
+      ENDIF
       !
    END SUBROUTINE ctl_stop
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 2613)
@@ -2,8 +2,9 @@
    !!======================================================================
    !!                 ***  MODULE  sbc_ice  ***
-   !!        parameter and  variables defined in memory in forced mode
+   !! Surface module - LIM-3: parameters & variables defined in memory
    !!======================================================================
-   !! History :  3.0  !  2006-08  (G. Madec)  Surface module
-   !!            3.2  !  2009-06  (S. Masson) merge with ice_oce
+   !! History :  3.0  ! 2006-08  (G. Madec)  Surface module
+   !!            3.2  ! 2009-06  (S. Masson) merge with ice_oce
+   !!            4.0  ! 2011-01  (A. R. Porter, STFC Daresbury) dynamical allocation
    !!----------------------------------------------------------------------
 #if defined key_lim3 || defined key_lim2
@@ -13,8 +14,8 @@
    USE par_oce          ! ocean parameters
 # if defined key_lim3
-   USE par_ice          ! ice parameters
+   USE par_ice          ! LIM-3 parameters
 # endif
 # if defined key_lim2
-   USE par_ice_2        ! ice parameters
+   USE par_ice_2        ! LIM-2 parameters
 # endif
 
@@ -39,17 +40,17 @@
 # endif
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qns_ice   !: non solar heat flux over ice                         [W/m2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qsr_ice   !: solar heat flux over ice                             [W/m2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qla_ice   !: latent flux over ice                                 [W/m2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dqla_ice  !: latent sensibility over ice                          [W/m2/K]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dqns_ice  !: non solar heat flux sensibility over ice (LW+SEN+LA) [W/m2/K]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tn_ice    !: ice surface temperature                              [K]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qns_ice   !: non solar heat flux over ice                  [W/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qsr_ice   !: solar heat flux over ice                      [W/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qla_ice   !: latent flux over ice                          [W/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dqla_ice  !: latent sensibility over ice                 [W/m2/K]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dqns_ice  !: non solar heat flux over ice (LW+SEN+LA)    [W/m2/K]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tn_ice    !: ice surface temperature                          [K]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   alb_ice   !: albedo of ice
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   utau_ice    !: u-stress over ice (I-pt for VP or U,V-pts for EVP)   [N/m2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   vtau_ice    !: v-stress over ice (I-pt for VP or U,V-pts for EVP)   [N/m2]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fr1_i0      !: 1st fraction of Qsr which penetrates inside the ice cover
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fr2_i0      !: 2nd fraction of Qsr which penetrates inside the ice cover
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   emp_ice     !: solid freshwater budget over ice: sublivation - snow
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   utau_ice    !: atmos-ice u-stress. VP: I-pt ; EVP: U,V-pts   [N/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   vtau_ice    !: atmos-ice v-stress. VP: I-pt ; EVP: U,V-pts   [N/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fr1_i0      !: 1st Qsr fraction penetrating inside ice cover    [-]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fr2_i0      !: 2nd Qsr fraction penetrating inside ice cover    [-]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   emp_ice     !: sublimation-snow budget over ice             [kg/m2]
 
 # if defined key_lim3
@@ -57,21 +58,28 @@
 # endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-  FUNCTION sbc_ice_alloc()
-    !!----------------------------------------------------------------------
-    !!----------------------------------------------------------------------
-    IMPLICIT none
-    INTEGER :: sbc_ice_alloc
-    !!----------------------------------------------------------------------
- 
-    ALLOCATE(qns_ice(jpi,jpj,jpl),  qsr_ice(jpi,jpj,jpl),               &
-             qla_ice(jpi,jpj,jpl),  dqla_ice(jpi,jpj,jpl),              &
-             dqns_ice(jpi,jpj,jpl), tn_ice(jpi,jpj,jpl),                &
-             alb_ice(jpi,jpj,jpl),                                      &
-             utau_ice(jpi,jpj),     vtau_ice(jpi,jpj), fr1_i0(jpi,jpj), &
-             fr2_i0(jpi,jpj),       emp_ice(jpi,jpj),                   &
-             Stat=sbc_ice_alloc)
-
+   FUNCTION sbc_ice_alloc()
+      !!----------------------------------------------------------------------
+     !!                     ***  FUNCTION sbc_ice_alloc  ***
+     !!
+     !! ** Purpose :   Allocate all the dynamic arrays in the modules
+      !!----------------------------------------------------------------------
+      INTEGER :: sbc_ice_alloc   ! return value
+      !!----------------------------------------------------------------------
+      !
+      ALLOCATE( qns_ice (jpi,jpj,jpl) , qsr_ice (jpi,jpj,jpl) ,     &
+         &      qla_ice (jpi,jpj,jpl) , dqla_ice(jpi,jpj,jpl) ,     &
+         &      dqns_ice(jpi,jpj,jpl) , tn_ice  (jpi,jpj,jpl) ,     &
+         &      alb_ice (jpi,jpj,jpl) ,                             &
+         &      utau_ice(jpi,jpj)     , vtau_ice(jpi,jpj)     ,     &
+         &      fr1_i0  (jpi,jpj)     , fr2_i0  (jpi,jpj)     ,     &
+         &      emp_ice(jpi,jpj)                              , STAT=sbc_ice_alloc)
+      !
   END FUNCTION sbc_ice_alloc
 
@@ -85,8 +93,4 @@
 #endif
 
-   !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE sbc_ice
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 2613)
@@ -63,5 +63,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 4.0 , UCL NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , UCL NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -146,14 +146,14 @@
          CASE( 3 )                                       ! CLIO bulk formulation
             CALL blk_ice_clio( t_su , zalb_ice_cs, zalb_ice_os,                           &
-               &                      utau_ice  , vtau_ice  , qns_ice   , qsr_ice   ,   &
-               &                      qla_ice   , dqns_ice  , dqla_ice  ,               &
-               &                      tprecip   , sprecip   ,                           &
-               &                      fr1_i0    , fr2_i0    , cp_ice_msh, jpl  )
+               &                      utau_ice   , vtau_ice   , qns_ice   , qsr_ice   ,   &
+               &                      qla_ice    , dqns_ice   , dqla_ice  ,               &
+               &                      tprecip    , sprecip    ,                           &
+               &                      fr1_i0     , fr2_i0     , cp_ice_msh, jpl  )
             !         
          CASE( 4 )                                       ! CORE bulk formulation
             CALL blk_ice_core( t_su , u_ice     , v_ice     , zalb_ice_cs,               &
-               &                      utau_ice  , vtau_ice  , qns_ice   , qsr_ice   ,   &
-               &                      qla_ice   , dqns_ice  , dqla_ice  ,               &
-               &                      tprecip   , sprecip   ,                           &
+               &                      utau_ice  , vtau_ice  , qns_ice    , qsr_ice   ,   &
+               &                      qla_ice   , dqns_ice  , dqla_ice   ,               &
+               &                      tprecip   , sprecip   ,                            &
                &                      fr1_i0    , fr2_i0    , cp_ice_msh, jpl  )
          END SELECT
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 2613)
@@ -57,11 +57,9 @@
       INTEGER :: tra_ldf_iso_grif_alloc
       !!----------------------------------------------------------------------
-
+      !
       ALLOCATE(zdkt(jpi,jpj,0:1), Stat=tra_ldf_iso_grif_alloc)
-
-      IF(tra_ldf_iso_grif_alloc /= 0)THEN
-         CALL ctl_warn('tra_ldf_iso_grif_alloc : allocation of arrays failed.')
-      END IF
-
+      !
+      IF( tra_ldf_iso_grif_alloc /= 0 )   CALL ctl_warn('tra_ldf_iso_grif_alloc : allocation of arrays failed.')
+      !
   END FUNCTION tra_ldf_iso_grif_alloc
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 2613)
@@ -72,12 +72,11 @@
       INTEGER :: trd_mld_alloc
       !!----------------------------------------------------------------------
-
+      !
       ALLOCATE(ndextrd1(jpi*jpj), Stat=trd_mld_alloc)
-
-      IF(trd_mld_alloc /= 0)THEN
-         CALL ctl_warn('trd_mld_alloc: failed to allocate array ndextrd1.')
-      END IF
-
+      !
+      IF( trd_mld_alloc /= 0 )   CALL ctl_warn('trd_mld_alloc: failed to allocate array ndextrd1.')
+      !
    END FUNCTION trd_mld_alloc
+
 
    SUBROUTINE trd_mld_zint( pttrdmld, pstrdmld, ktrd, ctype )
@@ -262,5 +261,6 @@
       USE wrk_nemo, ONLY: ztmltot2 => wrk_2d_7, ztmlres2 => wrk_2d_8, ztmltrdm2 => wrk_2d_9    ! \  working arrays to diagnose the trends
       USE wrk_nemo, ONLY: zsmltot2 => wrk_2d_10, zsmlres2 => wrk_2d_11, zsmltrdm2 => wrk_2d_12 !  > associated with the time meaned ML T & S
-      USE wrk_nemo, ONLY: ztmlatf2 => wrk_2d_13, zsmlatf2 => wrk_2d_14                         ! /
+      USE wrk_nemo, ONLY: ztmlatf2 => wrk_2d_13, zsmlatf2 => wrk_2d_14    
+      USE wrk_nemo, ONLY: wrk_3d_1, wrk_3d_2                     ! /
       !!
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
@@ -269,6 +269,5 @@
       LOGICAL :: lldebug = .TRUE.
       REAL(wp) :: zavt, zfn, zfn2
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  &
-           ztmltrd2, zsmltrd2               ! only needed for mean diagnostics
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztmltrd2, zsmltrd2   ! only needed for mean diagnostics
 #if defined key_dimgout
       INTEGER ::  iyear,imon,iday
@@ -282,5 +281,5 @@
          CALL ctl_stop('trd_mld : requested workspace arrays unavailable.')
          RETURN
-      ELSE IF(jpltrd > jpk)
+      ELSE IF(jpltrd > jpk) THEN
          ! ARPDBG, is this reasonable or will this cause trouble in the future?
          CALL ctl_stop('trd_mld : no. of mixed-layer trends (jpltrd) exceeds no. of model levels so cannot use 3D workspaces.')
@@ -288,6 +287,6 @@
       END IF
       ! Set-up pointers into sub-arrays of 3d-workspaces
-      ztmltrd2 => wrk_3d_1(:,:,1:jpltrd)
-      zsmltrd2 => wrk_3d_2(:,:,1:jpltrd)
+      ztmltrd2 => wrk_3d_1(1:,:,1:jpltrd)
+      zsmltrd2 => wrk_3d_2(1:,:,1:jpltrd)
 
       ! ======================================================================
